image:
  name: atreschilov/php-grpc:v0.1.7

services:
  - docker:dind

stages:
  - build
  - test
  - prepare-deploy
  - deploy

compile:
  stage: build
  script:
    - composer install
  cache:
    key: ${CI_COMMIT_REF_NAME}
    paths:
      - vendor/
  artifacts:
    paths:
      - app/
      - vendor/
      - public/
      - phpunit.xml
      - Dockfile
      - php.ini
    when: on_success
    expire_in: 1h

code-sniffer:
  stage: test
  only:
    - branches
  except:
    - tags
  dependencies:
    - compile
  script:
    - vendor/bin/phpcs --standard=PSR12 app/
  when: on_success

unit-tests:
  stage: test
  only:
    - branches
  except:
    - tags
  dependencies:
    - compile
  script:
    - pecl install xdebug-3.4.0 && docker-php-ext-enable xdebug
    - echo xdebug.mode=coverage > /usr/local/etc/php/conf.d/xdebug.ini
    - vendor/bin/phpunit tests/Unit --coverage-text
  artifacts:
    when: always
    reports:
      junit: tmp/logfile.xml
    expire_in: 1d
  when: on_success

build-image:
  stage: prepare-deploy
  only:
    - tags
  except:
    - branches
  image: docker:25.0.5-dind
  dependencies:
    - compile
  script:
    - docker build -t atreschilov/php_tinkoff_analytics:${CI_COMMIT_REF_NAME} .
    - docker login -u $DOCKER_HUB_LOGIN -p $DOCKER_HUB_API_KEY
    - docker tag atreschilov/php_tinkoff_analytics:${CI_COMMIT_REF_NAME} atreschilov/php_tinkoff_analytics:${CI_COMMIT_REF_NAME}
    - docker push atreschilov/php_tinkoff_analytics:${CI_COMMIT_REF_NAME}
  when: manual

deploy-to-prod:
  stage: deploy
  only:
    - tags
  except:
    - branches
  image: gitlab/dind
  script:
    - 'curl -i --insecure --header "X-DEPLOY-TOKEN: ${DEPLOY_WEBHOOK_SECRET}" "https://hakkes.com/deploy/tinkoff_analytics.php?version=${CI_COMMIT_REF_NAME}"'
  when: manual

deploy-consumers:
  stage: deploy
  only:
    - tags
  except:
    - branches
  image: gitlab/dind
  script:
    - 'curl -i --insecure --header "X-DEPLOY-TOKEN: ${DEPLOY_WEBHOOK_SECRET}" "https://hakkes.com/deploy/tinkoff_analytics_consumers.php"'
  when: manual

